package com.ruoyi.docking.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.annotation.DataSource;
import com.ruoyi.common.enums.DataSourceType;
import com.ruoyi.docking.entity.ProjectProgress;
import com.ruoyi.docking.mapper.ProjectProgressMapper;
import com.ruoyi.docking.service.ProjectProgressService;
import com.ruoyi.gysl.entity.BasicInformation;
import com.ruoyi.gysl.entity.request.ZwIdPageReq;
import com.ruoyi.gysl.service.BasicInformationService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.time.ZoneId;
import java.time.ZonedDateTime;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.Stream;

/**
 * 项目月度进度（对接数据）(ProjectProgress)表服务实现类
 *
 * @author makejava
 * @since 2025-03-25 14:49:04
 */
@Service("projectProgressService")
public class ProjectProgressServiceImpl extends ServiceImpl<ProjectProgressMapper, ProjectProgress> implements ProjectProgressService {

    @Resource
    private BasicInformationService basicInformationService;

    @Resource
    private ProjectProgressMapper projectProgressMapper;
    /**
     * 查询所有数据
     *
     * @param zwIdPageReq 查询实体
     * @return 所有数据
     */
    @Override
    public List<ProjectProgress> page(ZwIdPageReq zwIdPageReq) {
        //查询对应的项目基础信息数据
        BasicInformation byId = basicInformationService.getById(zwIdPageReq.getXmId());
        //获取对接的数据
        List<ProjectProgress> page = projectProgressMapper.page(byId.getName());
        List<ProjectProgress> list = lambdaQuery().eq(ProjectProgress::getXmId, byId.getId()).list();
        return new ArrayList<>(Stream.concat(list.stream(), page.stream())
                .collect(Collectors.toMap(
                        ProjectProgress::getMonth,
                        v -> v,
                        (existing, replacement) -> existing // 冲突时保留现有值（即list中的值）
                ))
                .values());
    }
}

